/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized.
* This software is owned by Renesas Electronics Corporation and is protected
* under all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY,
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
* PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY
* DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
* FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this
* software and to discontinue the availability of this software.
* By using this software, you agree to the additional terms and
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
*******************************************************************************/
/* Copyright (C) 2013 Renesas Electronics Corporation. All rights reserved.   */
/******************************************************************************/
/*******************************************************************************
* File Name : main.h
* Version : 1.10
* Device(s) : RL78/G14
* Tool-Chain : RL78 CubeSuite+ V2.01.00
* OS : None
* H/W Platform : RL78/G14 Target Board
* Description : RL78 IEC Self Test Library Main module Header file
* Operation : 
* Limitations : None
*******************************************************************************/

/********************************************************************************
* History :
* 30.05.2011 V1.00 First Release
* 15.11.2013 V1.10 Fixed some comments
*******************************************************************************/

#ifndef MAIN_H_INCLUDED
#define MAIN_H_INCLUDED


/******************************************************************************
Includes <System Includes> , "Project Includes"
******************************************************************************/



/******************************************************************************
Imported global variables and functions (to be accessed by other files)
******************************************************************************/
#ifdef hw_peripheral_crc_test_enabled
extern unsigned char g_referenceCalc_Done;
#endif

#ifdef sw_crc_test_enabled
extern unsigned char g_referenceCalc_CCIT16_MSB_Done;
#endif

//The setting value is for R5F104xJ(x = F, G, J, L, M, P)
//Please change according to the model number to be used
//end address of ROM(ROM capacity)
//Please change the definition of "CRC_SIZE" according to the application
//In the application note, "CRC_START_ADDRESSE" excludes a part of ROM such 
//as option byte / security ID.
//The monitor program is for initializing the communication interface for 
//debugging and RUN / break processing of the CPU. It is necessary to prevent 
//the user program and data from being placed in the area of the maximum of 768 
//bytes, which is the internal ROM end address or less.

//R5F104xA (x = A-C, E-G)
//#define	ROM_SIZE	0x04000U
//R5F104xC (x = A-C, E-G, J, L)
//#define	ROM_SIZE	0x08000U
//R5F104xD (x = A-C, E-G, J, L)
//#define	ROM_SIZE	0x0C000U
//R5F104xE (x = A-C, E-G, J, L)
//#define	ROM_SIZE	0x10000U
//R5F104xF (x = A-C, E-G, J, L, M, P)
//#define	ROM_SIZE	0x18000U
//R5F104xG (x = A-C, E-G, J, L, M, P)
//#define	ROM_SIZE	0x20000U
//R5F104xH (x = E-G, J, L, M, P)
//#define	ROM_SIZE	0x30000U
//R5F104xJ (x = F, G ,J , L, M, P)
#define		ROM_SIZE	0x40000U
//R5F104xK (x = G, L, M, P)
//#define	ROM_SIZE	0x60000U
//R5F104xL (x = G, L, M, P)
//#define	ROM_SIZE	0x80000U

#define		CRC_VALUE_SIZE		(2U)
#define		CRC_START_ADDRESSE	0x010CEU
#define		DEBUG_MONITOR_SIZE	(768)
#define		CRC_SIZE			(ROM_SIZE - CRC_START_ADDRESSE - DEBUG_MONITOR_SIZE - CRC_VALUE_SIZE )

#endif /* MAIN_H_INCLUDED      */
