;/*******************************************************************************
;* DISCLAIMER
;* This software is supplied by Renesas Electronics Corporation and is only
;* intended for use with Renesas products. No other uses are authorized. This
;* software is owned by Renesas Electronics Corporation and is protected under
;* all applicable laws, including copyright laws.
;* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
;* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
;* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
;* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
;* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
;* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
;* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
;* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
;* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
;* Renesas reserves the right, without notice, to make changes to this software
;* and to discontinue the availability of this software. By using this software,
;* you agree to the additional terms and conditions found by accessing the
;* following link:
;* http://www.renesas.com/disclaimer *
;* Copyright (C) 2013 Renesas Electronics Corporation. All rights reserved.
;*******************************************************************************/
;-------------------------------------
;	W-1	cstart
;
;-------------------------------------
	NAME	@cstart

$INCLUDE (def.inc)

;-----------------------------------------------------------------------------
; declaration of symbol
;
; attention):	change to EQU value 1 -> 0  if necessary
;-----------------------------------------------------------------------------
;
BRKSW	 EQU	1	;brk,sbrk,calloc,free,malloc,realloc function use
EXITSW	 EQU	1	;exit,atexit function use
RANDSW	 EQU	1	;rand,srand  function use
DIVSW	 EQU	1	;div	     function use
LDIVSW	 EQU	1	;ldiv 	     function use
FLOATSW	 EQU	1	;floating point variables use
STRTOKSW EQU	1	;strtok      function use
march_c_initial_test_enabled EQU 1
march_x_initial_test_enabled EQU 1


; The setting value is for R5F104xJ(x = F, G, J, L, M, P)
; Please change according to the model number to be used
; Start address of RAM
;R5F104xA (x = A-C, E-G))
;RAM_TOP         EQU    0FF500H
;R5F104xC (x = A-C, E-G, J, L)
;R5F104xE (x = A-C, E-G, J, L)) 
;RAM_TOP         EQU    0FEF00H
;R5F104xF (x = A-C, E-G, J, L, M, P))
;RAM_TOP         EQU    0FCF00H
;R5F104xG (x = A-C, E-G, J, L, M, P))
;RAM_TOP         EQU    0FBF00H
;R5F104xH (x = E-G, J, L, M, P))
;RAM_TOP         EQU    0FBF00H
;R5F104xJ (x = F, G, J, L, M, P))
RAM_TOP         EQU    0F9F00H
;R5F104xK (x = G, L, M, P))
;RAM_TOP         EQU    0F7F00H
;R5F104xL (x = G, L, M, P))
;RAM_TOP         EQU    0F3F00H

; End address of RAM excluding general register area
RAM_END         EQU    0FFEDFH
; When debugging with E1 / E20 / E2 Lite, use 4 bytes as the stack area for debugging. 
; For that reason, we will exclude that area from testing.
RAM_SIZE        EQU    (RAM_END - RAM_TOP + 1 - 4)

	PUBLIC	_@cstart,_@cend

$_IF(BRKSW)
	PUBLIC	_@BRKADR,_@MEMTOP,_@MEMBTM
$ENDIF
$_IF(EXITSW)
	PUBLIC	_@FNCTBL,_@FNCENT
$ENDIF
$_IF(RANDSW)
	PUBLIC	_@SEED
$ENDIF
$_IF(DIVSW)
	PUBLIC	_@DIVR
$ENDIF
$_IF(LDIVSW)
	PUBLIC	_@LDIVR
$ENDIF
$_IF(STRTOKSW)
	PUBLIC	_@TOKPTR
$ENDIF
$_IF(BRKSW OR FLOATSW)
	PUBLIC	_errno
$ENDIF

;-----------------------------------------------------------------------------
; external declaration of symbol for stack area
;
; _@STBEG has value of the end address +1 of compiler's stack area.
; _@STBEG is created by linker with -S option.
; Accordingly, specify the -S option when linking.
;
; _@MAA has value of the mirror area.
;-----------------------------------------------------------------------------
	EXTRN	_main,_@STBEG,_hdwinit,_low_level_init,_indicate_test_result,_LED_Display_Time_Delay

$_IF(march_c_initial_test_enabled)
        EXTRN  _stl_RL78_march_c_initial
$ENDIF

$_IF(march_x_initial_test_enabled)
        EXTRN  _stl_RL78_march_x_initial
$ENDIF

        PUBLIC  _stl_RL78_march_c_initial_finish 
        PUBLIC  _stl_RL78_march_x_initial_finish


$_IF(EXITSW)
	EXTRN	_exit
$ENDIF
$_IF(_MIRROR)
	EXTRN	_@MAA
$ENDIF

;-----------------------------------------------------------------------------
; external declaration of label for ROMable
;-----------------------------------------------------------------------------
	EXTRN	_?R_INIT,_?RLINIT,_?R_INIS,_?DATA,_?DATAL,_?DATS

;-----------------------------------------------------------------------------
; allocation area which library uses
;
; _@FNCTBL	top address of area used in atexit function
; _@FNCENT	total number of functions registered by the atexit function
; _@SEED	sequence of pseudo-random numbers
; _@DIVR	a result of div library
; _@LDIVR	a result of ldiv library
; _@TOKPTR	pointer which strtok function uses
; _errno	errno number code
; _@MEMTOP	top address of area which memory management functions use
; _@MEMBTM	bottom address of area which memory management functions use
; _@BRKADR	break value
;-----------------------------------------------------------------------------
@@DATA	DSEG	BASEP	;near

$_IF(EXITSW)
_@FNCTBL:	DS	4*32
_@FNCENT:	DS	2
$ENDIF
$_IF(RANDSW)
_@SEED:		DS	4
$ENDIF
$_IF(DIVSW)
_@DIVR:		DS	4
$ENDIF
$_IF(LDIVSW)
_@LDIVR:	DS	8
$ENDIF
$_IF(STRTOKSW)
$_IF(_DATAFAR)
_@TOKPTR:	DS	4
$ELSE
_@TOKPTR:	DS	2
$ENDIF
$ENDIF
$_IF(BRKSW OR FLOATSW)
_errno:		DS	2
$ENDIF
$_IF(BRKSW)
_@BRKADR:	DS	2
_@MEMTOP:	DS	32
_@MEMBTM:
$ENDIF


@@VECT00	CSEG	AT	0
	DW	_@cstart




@@LCODE	CSEG	BASE
_@cstart:
;-----------------------------------------------------------------------------
; setting the register bank RB0 as work register set
;-----------------------------------------------------------------------------
;	NOP
;	SEL	RB0
;-----------------------------------------------------------------------------
; setting the mirror area
;-----------------------------------------------------------------------------
$_IF(_MIRROR)
	MOV	A,#_@MAA
	MOV1	CY,A.0
	MOV1	MAA,CY
$ENDIF
;-----------------------------------------------------------------------------
; setting the stack pointer
;
; _@STBEG is created by linker with -S option.
;-----------------------------------------------------------------------------
	MOVW	SP,#LOWW _@STBEG	;SP <- stack begin address
	CALL	!!_hdwinit
;-----------------------------------------------------------------------------
; errno and _@FNCENT are initialized to 0
;
; The positive error number will be set by several libraries at called them.
;-----------------------------------------------------------------------------
$_IF(BRKSW OR EXITSW OR RANDSW OR FLOATSW)
	CLRW	AX
$ENDIF
$_IF(BRKSW OR FLOATSW)
	MOVW	!_errno,AX	;errno <- 0
$ENDIF
$_IF(EXITSW)
	MOVW	!_@FNCENT,AX	;FNCENT <- 0
$ENDIF
;-----------------------------------------------------------------------------
; initializing _@SEED as 1
;
; Pseudo-random sequence is decided by _@SEED value. This value can be set by
; srand function. If rand is called before srand, the random sequence will
; be the same as when srand is called with a _@SEED value as 1 at first.
;-----------------------------------------------------------------------------
$_IF(RANDSW)
	MOVW	!_@SEED+2,AX
	ONEW	AX
	MOVW	!_@SEED,AX	;SEED <- 1
$ENDIF
;-----------------------------------------------------------------------------
; setting _@MEMTOP address to _@BRKADR
;-----------------------------------------------------------------------------
$_IF(BRKSW)
	MOVW	AX,#_@MEMTOP
	MOVW	!_@BRKADR,AX	;BRKADR <- #MEMTOP
$ENDIF

;#########################################################################################
;  from here included for 60730 test stuff 
$_IF((march_c_initial_test_enabled) OR (march_x_initial_test_enabled))
       MOVW  SP,#LOWW(RAM_END + 1)
$ENDIF

$_IF(march_c_initial_test_enabled)
;~~~~~~~startaddress of March C- test in register AX
       movw  AX,#LOWW RAM_TOP
;~~~~~~~length of March C- test in register BC~~~~~~~       
       movw  BC,#LOWW RAM_SIZE
;~~~~~~~branche to march c- test ~~~~~~~~~~~~~~~~~~~~      
        BR    _stl_RL78_march_c_initial
;~~~~~~~testresult of March C- test in Register A -- 0x00 > no failure; 0x01 > failure        
_stl_RL78_march_c_initial_finish:
        MOV   0FEE8H, A
$ELSE
_stl_RL78_march_c_initial_finish:
$ENDIF
;~~~~~~~branche to march-x test ~~~~~~~~~~~~~~~~~~~~ 
$_IF(march_x_initial_test_enabled)
;~~~~~~~startaddress of March X- test in register AX
        movw  AX,#LOWW RAM_TOP
;~~~~~~~length of March X- test in register BC~~~~~~~       
        movw  BC,#LOWW RAM_SIZE
       BR    _stl_RL78_march_x_initial
;~~~~~~~testresult of March C- test in Register A -- 0x00 > no failure; 0x01 > failure
_stl_RL78_march_x_initial_finish:
        MOV   0FEE9H, A
$ELSE
_stl_RL78_march_x_initial_finish:
$ENDIF

$_IF((march_c_initial_test_enabled) OR (march_x_initial_test_enabled))
	MOVW	SP,#LOWW _@STBEG	;SP <- stack begin address
$ENDIF

;  end of inclusion for 60730 test stuff
;#########################################################################################


;######################################################################################
; included to display test result on eva board for march-c initial     
	CALL	!!_low_level_init
$_IF(march_c_initial_test_enabled)
; indicate test result initial march-c test
       MOV     X,  0FEE8H 
	   MOV     A,  #0H
       CALL    !!_indicate_test_result       
$ENDIF

$_IF((march_c_initial_test_enabled) OR (march_x_initial_test_enabled))
       CALL    !!_LED_Display_Time_Delay
$ENDIF

$_IF(march_x_initial_test_enabled)
; indicate test result initial march-x test        
       MOV     X,  0FEE9H
	   MOV     A,  #0H
       CALL !!_indicate_test_result 
$ENDIF
;  end of inclusion for 60730 test stuff
;######################################################################################

;-----------------------------------------------------------------------------
; clear saddr
;-----------------------------------------------------------------------------
	MOV	B,#0FEDFH-0FE20H+1
	CLRW	AX
LSADR1:
	DEC	B
	DEC	B
	MOVW	0FE20H[B],AX
	BNZ	$LSADR1

;-----------------------------------------------------------------------------
; ROM data copy
;-----------------------------------------------------------------------------

; copy external variables having initial value
$_IF(_ESCOPY)
	MOV	ES,#HIGHW _@R_INIT
$ENDIF
	MOVW	HL,#LOWW _@R_INIT
	MOVW	DE,#LOWW _@INIT
	BR	$LINIT2
LINIT1:
$_IF(_ESCOPY)
	MOV	A,ES:[HL]
$ELSE
	MOV	A,[HL]
$ENDIF
	MOV	[DE],A
	INCW	HL
	INCW	DE
LINIT2:
	MOVW	AX,HL
	CMPW	AX,#LOWW _?R_INIT
	BNZ	$LINIT1
$_IF(_DATAFAR)
; copy external variables having initial value
	MOVW	HL,#LOWW _@RLINIT
	MOVW	DE,#LOWW _@INITL
	BR	$LINIT4
LINIT3:
	MOV	ES,#HIGHW _@RLINIT
	MOV	A,ES:[HL]
	MOV	ES,#HIGHW _@INITL
	MOV	ES:[DE],A
	INCW	HL
	INCW	DE
LINIT4:
	MOVW	AX,HL
	CMPW	AX,#LOWW _?RLINIT
	BNZ	$LINIT3
$ENDIF
; copy external variables which doesn't have initial value
	MOVW	HL,#LOWW _@DATA
	MOVW	AX,#LOWW _?DATA
	BR	$LDATA2
LDATA1:
	MOV	[HL+0],#0
	INCW	HL
LDATA2:
	CMPW	AX,HL
	BNZ	$LDATA1
$_IF(_DATAFAR)
; copy external variables which doesn't have initial value
	MOV	ES,#HIGHW _@DATAL
	MOVW	HL,#LOWW _@DATAL
	MOVW	AX,#LOWW _?DATAL
	BR	$LDATA4
LDATA3:
	MOV	ES:[HL+0],#0
	INCW	HL
LDATA4:
	CMPW	AX,HL
	BNZ	$LDATA3
$ENDIF
; copy sreg variables having initial value
$_IF(_ESCOPY)
	MOV	ES,#HIGHW _@R_INIS
$ENDIF
	MOVW	HL,#LOWW _@R_INIS
	MOVW	DE,#LOWW _@INIS
	BR	$LINIS2
LINIS1:
$_IF(_ESCOPY)
	MOV	A,ES:[HL]
$ELSE
	MOV	A,[HL]
$ENDIF
	MOV	[DE],A
	INCW	HL
	INCW	DE
LINIS2:
	MOVW	AX,HL
	CMPW	AX,#LOWW _?R_INIS
	BNZ	$LINIS1

; copy sreg variables which doesn't have initial value
	MOVW	HL,#LOWW _@DATS
	MOVW	AX,#LOWW _?DATS
	BR	$LDATS2
LDATS1:
	MOV	[HL+0],#0
	INCW	HL
LDATS2:
	CMPW	AX,HL
	BNZ	$LDATS1

;-----------------------------------------------------------------------------
; call main function
;-----------------------------------------------------------------------------
	CALL	!!_main		;main();
;-----------------------------------------------------------------------------
; call exit function
;-----------------------------------------------------------------------------
$_IF(EXITSW)
	CLRW	AX
	CALL	!!_exit		;exit(0);
$ENDIF
	BR	$$
;
_@cend:
;-----------------------------------------------------------------------------
; define segment and label used by ROMable processing
;-----------------------------------------------------------------------------
@@R_INIT	CSEG	UNIT64KP
_@R_INIT:
$_IF(_DATAFAR)
@@RLINIT	CSEG	UNIT64KP
_@RLINIT:
$ENDIF
@@R_INIS	CSEG	UNIT64KP
_@R_INIS:
@@INIT	DSEG	BASEP
_@INIT:
$_IF(_DATAFAR)
@@INITL	DSEG	UNIT64KP
_@INITL:
$ENDIF
@@DATA	DSEG	BASEP
_@DATA:
$_IF(_DATAFAR)
@@DATAL	DSEG	UNIT64KP
_@DATAL:
$ENDIF
@@INIS	DSEG	SADDRP
_@INIS:
@@DATS	DSEG	SADDRP
_@DATS:
@@CALT	CSEG	CALLT0
@@CNST	CSEG	MIRRORP
@@CNSTL	CSEG	PAGE64KP
@@BITS	BSEG
;
	END
